//**********************************************************************
// CRhsEventLogReader.cpp
// ----------------------
// The CRhsEventLogReader class is a thin wrapper round the
// CRhsEventLog class. Most methods simply call the corresponding
// CRhsEventLog method then do whatever data mangling is required by
// COM.
//
// John Rennie
// john.rennie@ratsauce.co.uk
// 20th December 2006
//**********************************************************************

#ifndef __RHSEVENTLOGREADER_H_
#define __RHSEVENTLOGREADER_H_

#include "resource.h"       // main symbols
#include <RhsEventLog/RhsEventLog.h>

/////////////////////////////////////////////////////////////////////////////
// CRhsEventLogReader
class ATL_NO_VTABLE CRhsEventLogReader : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CRhsEventLogReader, &CLSID_RhsEventLogReader>,
	public IDispatchImpl<IRhsEventLogReader, &IID_IRhsEventLogReader, &LIBID_RHSEVENTLOGREADERLib>
{
public:
	CRhsEventLogReader()
	{ 
    m_EventLog = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_RHSEVENTLOGREADER)

BEGIN_COM_MAP(CRhsEventLogReader)
	COM_INTERFACE_ENTRY(IRhsEventLogReader)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IRhsEventLogReader
public:
	STDMETHOD(Message)(/*[out,retval]*/  BSTR* Result);
	STDMETHOD(EventID)(/*[out,retval]*/ long* Result);
	STDMETHOD(Source)(/*[out,retval]*/  BSTR* Result);
	STDMETHOD(EventTime)(/*[out,retval]*/ double* Result);
	STDMETHOD(EventType)(/*[out,retval]*/ BSTR* Result);
	STDMETHOD(ReadRecord)(/*[out,retval]*/ long* Result);
	STDMETHOD(CloseLog)(/*[out,retval]*/ long* Result);
	STDMETHOD(OpenLog)(/*[in]*/ BSTR Type, /*[in]*/ int ReadBack, /*[in]*/ BSTR Computer, /*[out,retval]*/ long* Result);

// Add the CRhsEventLog variable here

private:
  CRhsEventLog* m_EventLog;
};

#endif //__RHSEVENTLOGREADER_H_
