' **********************************************************************
' Example.vbs
' ===========
' This is an example script showing how to use the RhsEventlogReader
' object.
'
' John Rennie
' john.rennie@ratsauce.co.uk
' 20th December 2006
' **********************************************************************

option explicit

dim reader
dim eventtype, eventtime, source, eventid, message
dim i

' *** Create the object
' *** If this fails try "regsvr32 RhsEventLogReader.dll"

set reader = CreateObject("Rhs.RhsEventLogReader.1")

' *** Open the event log on this computer.
' *** We're opening it in reverse order i.e. most recent event first.

i = reader.OpenLog("System", 1, "")

if i = 0 then
  wscript.echo "Cannot open the event log"
  wscript.quit 2
end if

wscript.echo "System log opened"

' *** For this example just read the ten most recent events and print
' *** them.

for i = 1 to 10
  eventtype = reader.EventType()
  eventtime = formatdatetime(reader.EventTime(), 0)
  source    = reader.Source()
  eventid   = cstr(reader.EventId())
  message   = reader.Message()

' *** Strip carriage returns out of the message

  message = replace(message, chr(13) & chr(10), "<CR>")

' *** Print the event

  wscript.echo eventtype & chr(9) _
             & eventtime & chr(9) _
             & source & chr(9) _
             & eventid & chr(9) _
             & message

' *** Load the next record; if this fails exit the loop.

  if reader.ReadRecord() = 0 then
    wscript.echo "ReadRecord returned 0"
    exit for
  end if
next

' *** All done, close the log

reader.CloseLog()
wscript.echo "System log closed"

set reader = nothing
